(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('ng-drag-drop-plus', ['exports', '@angular/core', 'rxjs'], factory) :
    (global = global || self, factory(global['ng-drag-drop-plus'] = {}, global.ng.core, global.rxjs));
}(this, function (exports, core, rxjs) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgDragDropPlusService = /** @class */ (function () {
        function NgDragDropPlusService() {
            this.onDragSub = new rxjs.Subject();
            this.onDropSub = new rxjs.Subject();
        }
        NgDragDropPlusService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgDragDropPlusService.ctorParameters = function () { return []; };
        /** @nocollapse */ NgDragDropPlusService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function NgDragDropPlusService_Factory() { return new NgDragDropPlusService(); }, token: NgDragDropPlusService, providedIn: "root" });
        return NgDragDropPlusService;
    }());
    var DraggedEvent = /** @class */ (function () {
        function DraggedEvent(init) {
            this.event = {};
            this.source = '';
            this.destination = '';
            Object.assign(this, init);
        }
        return DraggedEvent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DraggableDirective = /** @class */ (function () {
        function DraggableDirective(el) {
            this.el = el;
            this.draggable = true;
        }
        /**
         * @param {?} event
         * @return {?}
         */
        DraggableDirective.prototype.dragStart = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            event.dataTransfer.setData('text', JSON.stringify({ dragData: this.dragData, dragSource: this.dragSource }));
        };
        DraggableDirective.decorators = [
            { type: core.Directive, args: [{
                        // tslint:disable-next-line: directive-selector
                        selector: '[draggable]'
                    },] }
        ];
        /** @nocollapse */
        DraggableDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        DraggableDirective.propDecorators = {
            dragData: [{ type: core.Input }],
            dragSource: [{ type: core.Input }],
            draggable: [{ type: core.HostBinding, args: ['draggable',] }],
            dragStart: [{ type: core.HostListener, args: ['dragstart', ['$event'],] }]
        };
        return DraggableDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DroppableDirective = /** @class */ (function () {
        function DroppableDirective(el, dragDropPlusService) {
            this.el = el;
            this.dragDropPlusService = dragDropPlusService;
        }
        /**
         * @param {?} event
         * @return {?}
         */
        DroppableDirective.prototype.ondragover = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            event.preventDefault();
        };
        /**
         * @param {?} event
         * @return {?}
         */
        DroppableDirective.prototype.ondrag = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            /** @type {?} */
            var obj = JSON.parse(event.dataTransfer.getData('text'));
            /** @type {?} */
            var dragEvent = new DraggedEvent({
                event: event,
                data: obj.dragData,
                source: obj.dragSource,
                destination: this.dragDestination
            });
            this.dragDropPlusService.onDropSub.next(dragEvent);
        };
        DroppableDirective.decorators = [
            { type: core.Directive, args: [{
                        // tslint:disable-next-line: directive-selector
                        selector: '[droppable]'
                    },] }
        ];
        /** @nocollapse */
        DroppableDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: NgDragDropPlusService }
        ]; };
        DroppableDirective.propDecorators = {
            dragDestination: [{ type: core.Input }],
            ondragover: [{ type: core.HostListener, args: ['dragover', ['$event'],] }],
            ondrag: [{ type: core.HostListener, args: ['drop', ['$event'],] }]
        };
        return DroppableDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgDragDropPlusModule = /** @class */ (function () {
        function NgDragDropPlusModule() {
        }
        /**
         * @return {?}
         */
        NgDragDropPlusModule.forRoot = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: NgDragDropPlusModule,
                providers: [NgDragDropPlusService]
            };
        };
        NgDragDropPlusModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [DraggableDirective, DroppableDirective],
                        imports: [],
                        exports: [DraggableDirective, DroppableDirective]
                    },] }
        ];
        return NgDragDropPlusModule;
    }());

    exports.DraggedEvent = DraggedEvent;
    exports.NgDragDropPlusModule = NgDragDropPlusModule;
    exports.NgDragDropPlusService = NgDragDropPlusService;
    exports.ɵa = DraggableDirective;
    exports.ɵb = DroppableDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ng-drag-drop-plus.umd.js.map
