import { Injectable, ɵɵdefineInjectable, Directive, ElementRef, Input, HostBinding, HostListener, NgModule } from '@angular/core';
import { Subject } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgDragDropPlusService {
    constructor() {
        this.onDragSub = new Subject();
        this.onDropSub = new Subject();
    }
}
NgDragDropPlusService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgDragDropPlusService.ctorParameters = () => [];
/** @nocollapse */ NgDragDropPlusService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgDragDropPlusService_Factory() { return new NgDragDropPlusService(); }, token: NgDragDropPlusService, providedIn: "root" });
class DraggedEvent {
    /**
     * @param {?=} init
     */
    constructor(init) {
        this.event = {};
        this.source = '';
        this.destination = '';
        Object.assign(this, init);
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DraggableDirective {
    /**
     * @param {?} el
     */
    constructor(el) {
        this.el = el;
        this.draggable = true;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    dragStart(event) {
        event.dataTransfer.setData('text', JSON.stringify({ dragData: this.dragData, dragSource: this.dragSource }));
    }
}
DraggableDirective.decorators = [
    { type: Directive, args: [{
                // tslint:disable-next-line: directive-selector
                selector: '[draggable]'
            },] }
];
/** @nocollapse */
DraggableDirective.ctorParameters = () => [
    { type: ElementRef }
];
DraggableDirective.propDecorators = {
    dragData: [{ type: Input }],
    dragSource: [{ type: Input }],
    draggable: [{ type: HostBinding, args: ['draggable',] }],
    dragStart: [{ type: HostListener, args: ['dragstart', ['$event'],] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DroppableDirective {
    /**
     * @param {?} el
     * @param {?} dragDropPlusService
     */
    constructor(el, dragDropPlusService) {
        this.el = el;
        this.dragDropPlusService = dragDropPlusService;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    ondragover(event) {
        event.preventDefault();
    }
    /**
     * @param {?} event
     * @return {?}
     */
    ondrag(event) {
        /** @type {?} */
        const obj = JSON.parse(event.dataTransfer.getData('text'));
        /** @type {?} */
        const dragEvent = new DraggedEvent({
            event,
            data: obj.dragData,
            source: obj.dragSource,
            destination: this.dragDestination
        });
        this.dragDropPlusService.onDropSub.next(dragEvent);
    }
}
DroppableDirective.decorators = [
    { type: Directive, args: [{
                // tslint:disable-next-line: directive-selector
                selector: '[droppable]'
            },] }
];
/** @nocollapse */
DroppableDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: NgDragDropPlusService }
];
DroppableDirective.propDecorators = {
    dragDestination: [{ type: Input }],
    ondragover: [{ type: HostListener, args: ['dragover', ['$event'],] }],
    ondrag: [{ type: HostListener, args: ['drop', ['$event'],] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgDragDropPlusModule {
    /**
     * @return {?}
     */
    static forRoot() {
        return {
            ngModule: NgDragDropPlusModule,
            providers: [NgDragDropPlusService]
        };
    }
}
NgDragDropPlusModule.decorators = [
    { type: NgModule, args: [{
                declarations: [DraggableDirective, DroppableDirective],
                imports: [],
                exports: [DraggableDirective, DroppableDirective]
            },] }
];

export { DraggedEvent, NgDragDropPlusModule, NgDragDropPlusService, DraggableDirective as ɵa, DroppableDirective as ɵb };
//# sourceMappingURL=ng-drag-drop-plus.js.map
