import { ɵɵdefineInjectable, Injectable, Directive, ElementRef, Input, HostBinding, HostListener, NgModule } from '@angular/core';
import { Subject } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgDragDropPlusService = /** @class */ (function () {
    function NgDragDropPlusService() {
        this.onDragSub = new Subject();
        this.onDropSub = new Subject();
    }
    NgDragDropPlusService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgDragDropPlusService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgDragDropPlusService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgDragDropPlusService_Factory() { return new NgDragDropPlusService(); }, token: NgDragDropPlusService, providedIn: "root" });
    return NgDragDropPlusService;
}());
var DraggedEvent = /** @class */ (function () {
    function DraggedEvent(init) {
        this.event = {};
        this.source = '';
        this.destination = '';
        Object.assign(this, init);
    }
    return DraggedEvent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DraggableDirective = /** @class */ (function () {
    function DraggableDirective(el) {
        this.el = el;
        this.draggable = true;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    DraggableDirective.prototype.dragStart = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        event.dataTransfer.setData('text', JSON.stringify({ dragData: this.dragData, dragSource: this.dragSource }));
    };
    DraggableDirective.decorators = [
        { type: Directive, args: [{
                    // tslint:disable-next-line: directive-selector
                    selector: '[draggable]'
                },] }
    ];
    /** @nocollapse */
    DraggableDirective.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    DraggableDirective.propDecorators = {
        dragData: [{ type: Input }],
        dragSource: [{ type: Input }],
        draggable: [{ type: HostBinding, args: ['draggable',] }],
        dragStart: [{ type: HostListener, args: ['dragstart', ['$event'],] }]
    };
    return DraggableDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DroppableDirective = /** @class */ (function () {
    function DroppableDirective(el, dragDropPlusService) {
        this.el = el;
        this.dragDropPlusService = dragDropPlusService;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    DroppableDirective.prototype.ondragover = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        event.preventDefault();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    DroppableDirective.prototype.ondrag = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var obj = JSON.parse(event.dataTransfer.getData('text'));
        /** @type {?} */
        var dragEvent = new DraggedEvent({
            event: event,
            data: obj.dragData,
            source: obj.dragSource,
            destination: this.dragDestination
        });
        this.dragDropPlusService.onDropSub.next(dragEvent);
    };
    DroppableDirective.decorators = [
        { type: Directive, args: [{
                    // tslint:disable-next-line: directive-selector
                    selector: '[droppable]'
                },] }
    ];
    /** @nocollapse */
    DroppableDirective.ctorParameters = function () { return [
        { type: ElementRef },
        { type: NgDragDropPlusService }
    ]; };
    DroppableDirective.propDecorators = {
        dragDestination: [{ type: Input }],
        ondragover: [{ type: HostListener, args: ['dragover', ['$event'],] }],
        ondrag: [{ type: HostListener, args: ['drop', ['$event'],] }]
    };
    return DroppableDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgDragDropPlusModule = /** @class */ (function () {
    function NgDragDropPlusModule() {
    }
    /**
     * @return {?}
     */
    NgDragDropPlusModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: NgDragDropPlusModule,
            providers: [NgDragDropPlusService]
        };
    };
    NgDragDropPlusModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [DraggableDirective, DroppableDirective],
                    imports: [],
                    exports: [DraggableDirective, DroppableDirective]
                },] }
    ];
    return NgDragDropPlusModule;
}());

export { DraggedEvent, NgDragDropPlusModule, NgDragDropPlusService, DraggableDirective as ɵa, DroppableDirective as ɵb };
//# sourceMappingURL=ng-drag-drop-plus.js.map
